// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.

#import "AppSpecificCell.h"
#import "math.h"
#import "Citizen.h"

@implementation AppSpecificCell

-setFlag
{
  flag=1;
  return self;
}


- (double)getAvgOpinion
{
  
   id index;
   id aPerson;
   int populationLevel;
   double opinion = 0;
   int n = 0;

   if( (populationLevel=[list getCount]) == 0) 
     opinion = 0;
   else {
     index = [list begin: [self getZone]];
     while((aPerson=[index next])!=NULL)
       { 
	 opinion += [aPerson  getOpinion];
	 n++;
       }
     opinion = (double) opinion/n;
     [index drop];
   }
   
   return (opinion);
}

- drawSelfOn: (id <Raster>)r;
{
  float color;
  int populationLevel = [list getCount];

  if (populationLevel==0) color= 104;
  else
    {
#ifndef NOPOSGRID
      double pct=100*[self getAvgOpinion];
      color = 104 + 0.62 * pct;
#else 
      color = 199;
#endif
    }
  [r drawPointX: x Y: y Color: floor( color + 0.5) ];
  return self;
}
@end






