// BatchSwarm.h


// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.


#import <objectbase.h>
#import <objectbase/Swarm.h>
#import "ModelSwarm.h"
#import "BatchRaster.h"
#import <analysis.h> // EZGraph

@interface BatchSwarm: Swarm
{
  int displayFrequency;	       		  // Frequency of fileI/O

  int experimentDuration;                 // When to Stop the Sim

  id displayActions;			  // schedule data structs
  id displaySchedule;
  id sequences; 
  ModelSwarm *modelSwarm;	 
                                         // The EZGraph will output data 
  id <EZGraph> opinionGraph;  
  BatchRaster * worldRaster;
  BatchColormap * colormap;
  id <Object2dDisplay> opinionDisplay;  //display onto worldRaster
  id <EZSequence> sequence;
}

+ createBegin: aZone;
- buildObjects;
- buildActions;
- activateIn: swarmContext;
- go;

- checkToStop;
- unattendedStop;
-(void) drop;

@end
