// Citizen.h


// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.


#import <space.h>		  //  Space features
#import <gui.h>
#import "LataneGrid.h"			 
#import "MultiGrid2d.h"


typedef enum { safe, riotous } ExtremeType;

@interface Citizen: SwarmObject
{
  id myUniformInt;   //a Swarm uniform distribution
  id myUniformDbl;   //a Swarm uniform double dist
  LataneGrid *opinionGrid;  //subclass of Discrete2d
  MultiGrid2d *positionGrid;	//subclass of Grid2d
  BOOL movement;  
  int idnum;
  int bolsteredMinority;
  int changedOpinion;
  int x, y; 
  int xlag, ylag;
  int citizenType;
  int age;	
  int worldXSize, worldYSize;	
  int periodsOpinion;
  int opinion;
  int opinionlag1;
  double pressureHere;
  double persuas;
  double support;
}

- setPositionGrid: (MultiGrid2d *)w OpinionGrid: (LataneGrid *)h; 

- createEnd;

- (void)setUniformDoubleDist: aDist;
- (void) setUniformIntegerDist: aDist;

- (void)setIDNumber: (int) anumber;

- (void)drawPandS;

- (void) setType: (int)aType;


- (void)setPersuas: (double)input;

- (double)getPersuas;

- (void)setSupport: (double)input;

- (double)getSupport;

- (void)setInitialOpinion: (int)x;
- (int)getOpinion;
- (int)getChanged;

- (int)getMinority;
- (double) getPressureHere;

- setMovement: (BOOL)mov;

- setX: (int)x Y: (int)y;			
- step;
- updateBeliefs;
- considerOpinion;
- (int)changeOpinion;

- (BOOL)scoutLocationX: (int*)newx Y: (int*)newy Discontent: (double*)newDiscontent;

- (double)findExtremeType: (ExtremeType)type X: (int*)x Y: (int*)y;

- (void)sayHi;

@end




