// Citizen1.m


// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.

#import "Citizen1.h"
#import <random.h>
#import <math.h>
#import "LataneGrid.h"

// Copyright Paul Johnson 2002. GPL. See COPYING

@implementation Citizen1

- considerOpinion
{
  BOOL agentMoved = NO;

  xlag = x;
  ylag = y;
  if (movement == YES)
    {
      int xx = x;
      int yy = y;
      double newPressure = pressureHere;

      // DB 2001-08-18. Self-Awareness Issue:
      // Note that scoutLocation and findExtremeType run 
      // prior to the removal of self from the world.  Thus in 
      // findExtremeType it is necessary to remove self from 
      // both numVisibleProt and numVisiblePeople in both sync and async.

      agentMoved = [self scoutLocationX: &xx Y: &yy Discontent: &newPressure];  

      if ( agentMoved == YES )
	{
	  x = xx;
	  y = yy;
	  pressureHere = newPressure;
	  [opinionGrid removeOpinion: opinion Persuasion: persuas Support: support AtX: xlag Y: ylag Type: citizenType];
	  if ( pressureHere > 50)
	    {
	      opinionlag1=opinion;
	      opinion=1-opinion; 
	      periodsOpinion = 0;
	      changedOpinion = 1;
	    }
	
	  [opinionGrid addOpinion: opinion Persuasion: persuas Support: support   AtX: x Y: y  Type: citizenType ];
	}
 
      else if ( pressureHere > 50 )
	{
	  //printf("Change: pressureHere =%f opinion=%d\n",pressureHere,opinion);
	  [self changeOpinion];
	}
      else 
	{
	  periodsOpinion++;
	  changedOpinion = 0;
	}
#ifndef NOPOSGRID  
      if (agentMoved == YES)
	{
	  [positionGrid deleteObject: self atX: xlag Y: ylag];
	  [positionGrid add: self atX: x Y: y];
	} 
#endif
    }
  else
    {

      //      printf("Change: pressureHere =%f opinion=%d\n",pressureHere,opinion);
      if ( pressureHere > 50 )
	{
	  [self changeOpinion];
	}
      else 
	{
	  changedOpinion = 0;
	  periodsOpinion++;
	}
    }
      
  return self; 
}

@end











