// LataneGrid.h

// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.


#import <space/Discrete2d.h>
#import <space.h>
#import "MultiGrid2d.h"

#define NUMTYPES 2 
#define OPINIONS 2

@interface LataneGrid: Discrete2d
//@interface LataneGrid: SwarmObject
{ 
  //first ones are needed to replace Discrete2d
  //long *offsets;
  //unsigned int xsize, ysize;
  BOOL wrapAround;
  BOOL SYNCHRONOUS;
  int num[OPINIONS][NUMTYPES];
  int numType[NUMTYPES];
  int numPPL;
  // int numPZero;
  int radius, correction;
 
  double ** accumP;
  double ** accumS;
  
  long * gridOffsets;

  double ** visibleP;
  double ** visibleS;

  long ** popChange;

  // MultiGrid2d * positionGrid;

  long ** visibleOpinion;
 }

+ create: aZone setSizeX: (unsigned)x Y: (unsigned)y;

- setNumPPL:(int)n;
- setNumType: (int)b To: (int)number;

- stepRule;

- (void) updateOpinion: (int) stance Impact: ( int) input X: (int) x Y: (int) y;

- (void) updateOpinionNoWrap: (int) stance Impact: ( int) input X: (int) x Y: (int) y;

//- (void) updateVisP: (int)stance Impact: (double) input X: (int) x Y: (int) y;

//- (void) updateVisPNoWrap: (int)stance Impact: (double) input X: (int) x Y: (int) y;

//- (void) updateVisS: (int)stance Impact: (double) input X: (int) x Y: (int) y;

//- (void) updateVisSNoWrap: (int)stance Impact: (double) input X: (int) x Y: (int) y;



- (void) updateDblPtr: (double*) p  Impact: (double) input X: (int) x Y: (int) y;


- (void) updateNoWrapDblPtr: (double*) p  Impact: (double) input X: (int) x Y: (int) y;

- (long)addOpinion: (int)stance Persuasion: (double)p Support: (double)s AtX: (int)x Y: (int)y Type: (int)aType;

- (long)removeOpinion: (int)stance Persuasion: (double)p Support: (double)s AtX: (int)x Y: (int)y Type: (int)aType;

- (double)getSupportFor: (int)stance InVicinityX: (int)x Y: (int)y N: (int*)n_ptr;

- (double)getPersuasionFor: (int)stance InVicinityX: (int)x Y: (int)y N: (int*)n_ptr;

- (int)getVisibleNOpinion:(int) op InVicinityX: (int) x Y: (int) y ;

- (double*)getPersuasionPointer: (int) op;

- (double*)getSupportPointer: (int)op;

- (long*)getOpinionPointer:(int)op;

- (long *)getGridOffsets;

- (double)getPct;
- (double)getPctType: (unsigned)aType;
- (double)getPctTypeOne;

- (void)printDiagnostics;

@end

//-(double) measureProtestInVicinityX: (int) x Y: (int) y Radius: (int) rad;







