// ModelSwarm.h

// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.

#import "Citizen.h"
#import "LataneGrid.h"
#import <objectbase/Swarm.h>
#import "MultiGrid2d.h"


@interface ModelSwarm: Swarm
{
  int numPOne;  //number of agents of type one  
  int numPTwo; //number of agents of type two
  int numPPL;	
  int citizensMove;
  int randomSeed;
  int citizenCount;

  int worldXSize, worldYSize; 

  double probYES;
  
  id modelSchedule;  // scheduling data structures

  id <Array> citizenList;  // list of all the citizens
  //  id <List> holdingList;

  id <Array> listTypeArray;// an array of lists, keeping different kinds of citizens separate (may need that detail someday!)

  FILE * summaryFile;
  char summaryFileName[50];
  BOOL SYNCHRONOUS;
  BOOL RANDOMIZED;
  //  id myUniformInt; //AN isolated source of randomness
  //  id myUniformDbl;
  MultiGrid2d * positionGrid;	 //agents put selves in locations
  LataneGrid * opinionGrid;    //opinion pressures throughout the grid
}

- getCitizenList;

- getListType: (int)x;

- (id <Grid2d>)getPositionGrid;		       
- (LataneGrid *)getInfluenceGrid;   
					
- createCitizen1X: (unsigned)x Y: (unsigned)y;
- createCitizen2X: (unsigned)x Y: (unsigned)y;


+ createBegin: aZone;		
- createEnd;			
- initializeRNGs;

- buildObjects;
- (void) stepThruCitizens ;

- buildActions;
- (void)initializeOutputFiles;

- finishLog;

//- chooseSubset;

- activateIn: swarmContext;

@end
