// ObserverSwarm.h

// Paul Johnson <pauljohn@ku.edu> 2002
// This code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify the author of their
// use and share their code with the original author.  A copy of version
// 2 of the GPL is included in this directory, but you can use a newer
// GPL at your choice.  The author assumes no liability for any 
// inconvenience or damage caused by this software and offers no 
// warranty of any kind.


#import <simtoolsgui.h>
#import <analysis.h>
#import "ModelSwarm.h"

#import <simtoolsgui/GUISwarm.h>

@interface ObserverSwarm: GUISwarm
{
  int displayFrequency;				// one parameter: update freq
  id sequences[3];

  id displayActions;				// schedule data structs
  id displaySchedule, displaySchedule2;

  id stopSchedule;

  ModelSwarm *modelSwarm;	  	// the Swarm we're observing
  id <Colormap> colormap;			// allocate colours
  id <ZoomRaster> opinionRaster;		// 2d display widget
  id <ZoomRaster> pressureRaster;	
  id <EZGraph> opinionGraph;       
  // Now, higher order display and data objects

  id <Value2dDisplay> pressureDisplay;	
  id <Object2dDisplay> opinionDisplay;	       
}

// Methods overriden to make the Swarm.

+ createBegin: aZone;
- createEnd;
- buildObjects;
- buildActions;
- activateIn: swarmContext;

- writeRasterPixmap;
- writeGraphPixmap;

- unattendedStop;

- guiStop;

-(void) drop;
@end









