
// Paul Johnson <pauljohn@ukans.edu> & David Brichoux
// <br9x5@lark.cc.ukans.edu>
//Copyright 2001 code is made available under the GPL (GNU general public license)
// with the additional proviso that any users notify use of their use
// and share their code with us.

#import <simtools.h>     // initSwarm () and swarmGUIMode
#import <simtoolsgui.h>  // GUISwarm
#import "ObserverSwarm.h"
#import "BatchSwarm.h"
#import "MyArguments.h"


int
main (int argc, const char **argv)
{
  id theTopLevelSwarm;

  initSwarmArguments (argc, argv, [MyArguments class]);

  //  printf("MyArguments says: %d \n",[arguments getNumpplArg]);
 
  arguments = (id) arguments;
  
  if (swarmGUIMode == 1)
    {
      theTopLevelSwarm = [ObserverSwarm createBegin: globalZone];
      SET_WINDOW_GEOMETRY_RECORD_NAME (theTopLevelSwarm);
      theTopLevelSwarm = [theTopLevelSwarm createEnd];
    }
  else
    theTopLevelSwarm = [BatchSwarm create: globalZone];

  arguments= [(MyArguments *) arguments init];

  if (swarmGUIMode == 1)
    {
      CREATE_ARCHIVED_PROBE_DISPLAY (arguments);
    }
  
  [theTopLevelSwarm buildObjects];
  [theTopLevelSwarm buildActions];
  [theTopLevelSwarm activateIn: nil];
  [theTopLevelSwarm go];

  if (getInt(arguments,"GUIshots")) [theTopLevelSwarm writeGraphPixmap];

  [theTopLevelSwarm drop];
  return 0;
}






